#!/bin/tclsh
set scripttime [clock seconds]

# --- https://homematic-forum.de/forum/viewtopic.php?f=31&t=73338

set hostname [exec uname -n]
### if { $hostname == "ccu3-webui" } { ... }

# ---
# ---

set ccu_host     "127.0.0.1"
set ccu_user     "Admin"

if { $hostname == "ccu3-webui" } {
  set ccu_password ""

  set rgba "64,0,64,0.60"
} else {
  set ccu_password ""

  set rgba "25,44,110,0.50"
}


# --- wo sollen ggf. die Systemprotokoll-Tagessicherungen abgelegt werden: ---
# --- (Verzeichnis muss existieren!)

set HB_ARCHIVE_DIR "../HB_Archive"
  set HB_ARCHIVE_DIR "/var/tmp/HB_Archive"

# puts $argv
if {    [regexp {\{HB_ARCHIVE_DIR=([^\}]*)\}} " $argv " dummy HB_ARCHIVE_DIR]
     || [regexp  { HB_ARCHIVE_DIR=([^ ]*) }   " $argv " dummy HB_ARCHIVE_DIR] 
} {
  # --- Auswertung unten, wenn klar ist, dass SAVE2HB_ARCHIV_ONLY==1 ---
  # ggf: mkdir /var/tmp/HB_Archive; ./show_logs.cgi f="[rega] Systemprotokoll" SAVE2HB_ARCHIV=1 HB_ARCHIVE_DIR=/var/tmp/HB_Archive
}


# --- webgui / Programme / Skript testen ...
#
# string stdout; string stderr;
# system.Exec( 'cd /usr/local/etc/config/addons/ste/www;
#   ./show_logs.cgi f="[rega] Systemprotokoll" SAVE2HB_ARCHIV=1 HB_ARCHIVE_DIR=XXX/var/tmp/HB_Archive
# ', &stdout, &stderr );
# WriteLine( "--- stdout: ---\n" # stdout); WriteLine( "--- stderr: ---\n" # stderr);


# --- crontab ---
#
# --- stuendlich Systemprotokoll-Tagessicherung fortschreiben: ---
# 59 *  * *  *  sleep $(( 15 + $RANDOM % 15 )); cd /usr/local/etc/config/addons/ste/www; \
#     nice logger -p cron.info -t "crond[$(cat /var/run/crond.pid)]" "USER $(whoami) PID $$ CMD www/show_logs.cgi Systemprotokoll SAVE2HB_ARCHIV"; \
#     nice ./show_logs.cgi f="[rega] Systemprotokoll" SAVE2HB_ARCHIV=1 > /var/log/show_logs-Systemprotokoll-SAVE2HB_ARCHIV.log 2>&1
#
# --- taeglich Systemprotokoll-Tagessicherungen-Dateien mit gewissem Alter wieder loeschen, hier 4 Wochen: ---
# 58 00 * *  *  sleep $(( 15 + $RANDOM % 15 )); cd /usr/local/etc/config/addons/ste; \
#     nice logger -p cron.info -t "crond[$(cat /var/run/crond.pid)]" "USER $(whoami) PID $$ CMD rm ./HB_Archive/*-HistoryBuffer-complete.csv -mtime +28"; \
#     nice find ./HB_Archive/ -type f -name "*-HistoryBuffer-complete.csv" -mtime +28 -exec rm -f {} \;


# ---
# ---

# howto/"Installations"-Anleitung:
# Archiv herunterladen und das enthaltene Verzeichnis komplett im addons/www-Ordner entpacken
#
# wget -q https://homematic-forum.de/forum/download/file.php?id=97... -O show_logs-...tgz
# rm  -rf  /usr/local/etc/config/addons/www/show_logs
# tar x -C /usr/local/etc/config/addons/www -z -f show_logs-...tgz
#
# /usr/local/etc/config/addons/www/show_logs/show_logs.cgi
#Content-type: text/html
#
#<!DOCTYPE html>
#...
#
# -> im Browser: http://ccuip-oder-name/addons/show_logs/show_logs.cgi
# ok!

# ---

load tclrega.so

### set ccu_host     "147.0.0.1"
### set ccu_password "xxx"

# --- schafft Org.-WebGUI-Log-Seite nicht! ---
# dom.GetObject(ID_SYSTEM_VARIABLES).Get( "log" ).State( "Strichpunkt ; hier!" );

# --- das geht: ---
# dom.GetObject(ID_SYSTEM_VARIABLES).Get( "log" ).State( "Zeile 1 mit Komma , hier und unten
# Zeile 2 mit Umlauten (aus WebGUI) äöüß ÄÖÜ und Kaufmans-Und & ...
# Zeile 3 mit noch einem Komma , und Strichpunkt ; hier + kleiner/groesser-Zeichen: < > !" );

# ---------------------------------------------------------------------------------------------------------------------------------------

# echo "load tclrega.so; rega_script { dom.GetObject(ID_SYSTEM_VARIABLES).Get( 'log' ).State( 'Zeile 1 mit Komma , hier und unten
# Zeile 2 mit Umlauten (aus shell-Skript) äöüß ÄÖÜ und Kaufmans-Und & ...
# Zeile 3 mit js... <script type=\'text/javascript\' language=\'javascript\'>alert(location.hostname);</script> alert?!
# Zeile 4 mit <html>-Tag Table-end: </table> und Body-end: </body> :)
# Zeile 5 -ENDE- mit noch einem Komma , und Strichpunkt ; hier + kleiner/groesser-Zeichen: < > !' ); }" | tclsh

# ---------------------------------------------------------------------------------------------------------------------------------------

source [file join [file dirname [info script]] collect_form.tcl]
COLLECT_FORM

# ---

if {   [info exists form(f)]              && $form(f) == "\[rega\] Systemprotokoll"
    && [info exists form(SAVE2HB_ARCHIV)] && $form(SAVE2HB_ARCHIV) == "1"
} {
  set SAVE2HB_ARCHIV_ONLY 1

  if ![file isdirectory $HB_ARCHIVE_DIR] {
    puts "# HB_ARCHIVE_DIR: '$HB_ARCHIVE_DIR'"
    puts "Verzeichnis existiert nicht, Abbruch!"
    exit
  }

} else {
  set SAVE2HB_ARCHIV_ONLY 0
}

# ---

set conv_html "
  [format %c 60]  {&lt;}
  [format %c 62]  {&gt;}
"
### set conv_html "{} {}"; # <--- diese Zeile einfuegen/aktivieren um html-Tags NICHT zu entschaerfen! <---

# set VALUE [string map $conv_html $VALUE]
# set VALUE [string map "{&lt;br&gt;\n} {<br>\n}" $VALUE]

# ---

# ------------------------ && [string first "\[rega\] " $form(f)] == 0
if { [info exists form(f)] && $form(f) == "\[rega\] Systemprotokoll"   } {
  ### set charset "iso-8859-1"
  # 22.04. 06:39:20 	log 	HmIP-BSL 001A5A499B4397:8 (oben), COMBINED_PARAMETER: L=8 (%), C=2 (grün)

  # vermutlich kommen bei "iso-8859-1" die Umlaute korrekt, die durch die HM-WebGUI-Programme/-Skripte erzeugt werden
  # - aber fuer die Umlaute aus den shell-/web-Skripten (.sh/.tcl/.cgi) braucht es "utf-8" :/
  # mit utf-8 und "encoding convertfrom(!) utf-8" passt dann beides?!

  set charset "utf-8"
  # 21.04. 17:50:22 	vWetter_aktuell 	Koenigsbach-Stein (DWD, 17:30 Uhr): Leicht bewölkt, bei 15 C, 47 %rF, 1008 hPa
  # aber:
  # 22.04. 06:39:20 	log 	HmIP-BSL 001A5A499B4397:8 (oben), COMBINED_PARAMETER: L=8 (%), C=2 (gr�n)

} else {
  set charset "utf-8"
}

# ---

if { ! $SAVE2HB_ARCHIV_ONLY } {

puts "Content-type: text/html\n\n<!DOCTYPE html>"

puts "<html>
<head>
  <title>myHM-[file tail [file rootname [info script]]] ($hostname)</title>

  <meta http-equiv=\"Content-Language\" content=\"de\">
  <meta http-equiv=\"Content-Type\"     content=\"text/html; charset=$charset\">
  <meta http-equiv=\"cache-control\"    content=\"no-cache\">
  <meta http-equiv=\"pragma\"           content=\"no-cache\">
  <meta http-equiv=\"expires\"          content=\"0\">

  <!-- meta http-equiv=\"refresh\" content=\"300;\" -->
  <script type='text/javascript' language='javascript'>
    var myReload;
    var Timeout = 180499;
 // var Timeout = 10000;
    var TimeoutStarted;
    var TimeoutInterval;

    function TimeoutShow() {
      diff = Math.round( Date.now() / 1000 ) - TimeoutStarted;
      rest = Math.round( Timeout    / 1000 ) - diff;
   // console.log( 'T-' + rest );
   // document.getElementById('time2reload_top'   ).innerHTML = ' (&circlearrowright; in ' + rest + '&thinsp;s)';
      document.getElementById('time2reload_bottom').innerHTML = ' (&circlearrowright; in ' + rest + '&thinsp;s)';
      document.getElementById('But_StopReload'    ).innerHTML = ' <b>stop</b> auto-refresh (&circlearrowright; in ' + rest + '&thinsp;s)';
      if ( rest <= 60 ) {
        clearInterval( TimeoutInterval );
        TimeoutInterval = window.setInterval( 'TimeoutShow()', 1000 );
      }
    }

    function myActReload() {
    //myReload = setTimeout( 'location.reload();', 60000 );
      myReload = setTimeout( 'document.getElementById(\"But_StopReload\").click();'
                           + 'document.getElementById(\"FormGo\"        ).submit();', Timeout );
   // console.log( Date() + ': +++ start Timeout: ' + Timeout );
      TimeoutStarted = Math.round( Date.now() / 1000 );
      TimeoutInterval = window.setInterval( 'TimeoutShow()', 5000 );
    }

    function myStopReload() {
      clearTimeout( myReload  );
      clearInterval( TimeoutInterval );
   // console.log( Date() + ': --- Timeout cleared' );
      document.getElementById('time2reload_top'   ).innerHTML = '';
      document.getElementById('time2reload_bottom').innerHTML = '';
      document.getElementById('But_StopReload'    ).innerHTML = '...';
    }

    myActReload();
  </script>

  <style>
    table {
      border-collapse: collapse;
    }

    td, th {
      border: 1px solid black;
      padding: 3px;
    }

    th { background-color: #EBECEE; !--lightgrey; }
  </style>

</head>
<body !-style=\"background-color:rgba($rgba)\">\n"

puts "<div align=\"center\"><a href=\"#bottom\" style=\"!-background-color:rgba($rgba); text-decoration: none;\"
  >&nbsp;<b>&bigtriangledown;&bigtriangledown;&bigtriangledown;</b>&nbsp;</a>
<span id=\"time2reload_top\"></span></div>"

# ---

puts "
  <p align=center style=\"background-color:rgba($rgba);\"><!-- &nbsp;<br -->
      <button id='But_ActReload'  style='display:none;' onclick=\"myActReload();
         document.getElementById('But_ActReload' ).style.display='none';
         document.getElementById('But_StopReload').style.display='';
         document.getElementById('FormGo').submit();
         // location.reload();\"
      ><b>start</b> auto-refresh</button>

      <button id='But_StopReload' style='display:;'     onclick=\"myStopReload();
         document.getElementById('But_ActReload' ).style.display='';
         document.getElementById('But_StopReload').style.display='none';\"
      ><b>stop</b> auto-refresh</button></p>\n"

}; # --- endif: ! SAVE2HB_ARCHIV_ONLY


# ---

# if { ![info exists form(f)] } { set form(f) "\[rega\] Systemprotokoll" }

# ---

set fl ""
append fl "\[rega\] Servicemeldungen\n"
append fl "\[rega\] Systemprotokoll\n"
append fl "\[rega\] Systemvariablen\n"
append fl "\[rega\] Geraete\n"
append fl "\[rega\] Programme\n"

# catch { append fl "[exec find $HB_ARCHIVE_DIR/ -type f -name "*-HistoryBuffer.csv" -mtime -2 | sort -r]\n" }

# --- Achtung: HB wird unten nochmal gebraucht! ---
catch { set HB       [exec find $HB_ARCHIVE_DIR/ -type f -name "*-HistoryBuffer.csv" -mtime -6 | sort -r]
  foreach l [split $HB      "\n"] { append fl "\[rega\] $l\n" }
}

# --- Achtung: HBcmplt wird unten nochmal gebraucht! ---
catch { set HBcmplt  [exec find $HB_ARCHIVE_DIR/ -type f -name "*-HistoryBuffer-complete.csv" -mtime -6 | sort -r]
  foreach l [split $HBcmplt "\n"] { append fl "\[rega\] $l\n" }
}

append fl "\[sh\] crontab -l\n"
append fl "\[sh\] dmesg\n"
append fl "\[sh\] uname -a; uptime; echo; free -m; echo; df -h; echo; top -b -n 1\n"

catch { set s [exec find ../backup-ccu         -type f -name "*.log" -mtime -366 | sort]
  foreach l [split $s "\n"] { append fl "\[sh\] ls -l $l; echo; cat $l\n" }
}
catch { set s [exec find ../backup-enc         -type f -name "*.log" -mtime -366 | sort]
  foreach l [split $s "\n"] { append fl "\[sh\] ls -l $l; echo; cat $l\n" }
}
catch { set s [exec find ../backup-sdcard-incr -type f -name "*.log" -mtime -366 | sort]
  foreach l [split $s "\n"] { append fl "\[sh\] ls -l $l; echo; cat $l\n" }
}

# --- Achtung: HB wird hier nochmal gebraucht! ---
if { [info exists HB]      } {
  foreach l [split $HB      "\n"] { append fl "$l\n" }
}
if { [info exists HBcmplt] } {
  foreach l [split $HBcmplt "\n"] { append fl "$l\n" }
}

catch { append fl "[exec find /var/log   -type f                                         | grep -v "\.gz\$" | sort -f]\n" }

if [file exists "../einkaufszettel.txt" ] {
  append fl "../einkaufszettel.txt\n" 
  append fl "\[sh\] ls -l ../einkaufszettel.txt; echo; cat ../einkaufszettel.txt\n"
}

# catch { append fl "[exec find ../                              -type f -name "*backup*log"         -mtime -2   | sort   ]\n" }
catch { append fl "[exec find ../feeds                          -type f -name "it-sec*.alles"       -mtime -2   | sort   ]\n" }
# catch { append fl "[exec find ../watchdog/data                 -type f -name "*.dat"               -mtime -1   | sort   ]\n" }

if [file exists "../program_backup-restore/save_all_programs.log" ] {
  append fl     "../program_backup-restore/save_all_programs.log\n"
# append fl     "\[sh\] cat ../program_backup-restore/save_all_programs.log\n"
  append fl     "\[sh\] cd ../program_backup-restore;ls -l save_all_programs.log;echo;cat save_all_programs.log\n"
}
# catch { append fl "[exec find ../program_backup-restore/backup/ -type f -name "*programlist.txt"    -mtime -3   -exec echo "\[sh\] cat {}" \; | sort -r]\n" }
catch { append fl "[exec find ../program_backup-restore/backup/ -type f -name "*programlist.txt"    -mtime -3   | sort -r]\n" }

catch { append fl "[exec find ../termine -maxdepth 1            -type f -name "*.txt"                           | sort -f]\n" }
catch { append fl "[exec find ../termine                        -type f -name "error-log-????.txt*" -mtime -730 | sort -r]\n" }

catch { append fl "[exec find /tmp                              -type f -name "met-no*.*"           -mtime -7   | sort -r]\n" }

# puts "<pre>$fl</pre>"

# ---


if { ! $SAVE2HB_ARCHIV_ONLY } {

set selected 0
puts "<form id=\"FormGo\" action=\"[file tail [info script]]\" method=\"POST\" accept-charset=\"charset=$charset\" !-accept-charset=\"utf-8\">"
puts "<select name=\"f\" size=1 onchange=\"document.getElementById('But_StopReload').click(); this.form.submit();\">"
if { ![info exists form(f)] } {
   puts "  <option selected value=\"\"></option>"
} else {
   puts "  <option value=\"\"></option>"
}
foreach li [split [string trim $fl] "\n"] {
  if { [string trim $li] == "" } { continue }
  puts -nonewline "  <option"
  if { [info exists form(f)] && $form(f) == $li } {
    puts -nonewline " selected"
    set selected 1
  }
  puts " value=\"$li\">$li</option>"
}
puts "</select>"
puts "</form>\n"

} else {
  set selected 1
}; # --- endif: ! SAVE2HB_ARCHIV_ONLY


# ---

set bgcols "linen cornsilk"; # beige aliceblue cornsilk lightgrey whitesmoke

# puts "$form(f)"; exit

# ---  
# ---  

  if { $selected
        || ( [info exists form(f)] && [file exists $form(f)] )
  } {

# ---  
# ---  

if { [info exists form(f)] && [string first "\[sh\] " $form(f)] == 0 } {

  set cmd [string range $form(f) 5 end]
  # puts "sh cmd: '$cmd'<p>"

  if { [catch { set fd [exec nice sh -c "$cmd"] } errmsg] } {
    # set fd ""
    puts "<span style=\"color:red; font-weight:bold;\">$errmsg</span><br>"

  } else {
    puts "<pre><table border=0 align=center cellpadding=0 cellspacing=0
      style=\"color:white; background-color:black;\"><tr><td>[string map $conv_html [string trim $fd]]</td></tr></table></pre>"
  }


} elseif { [info exists form(f)] && [file exists $form(f)] } {

  if [catch {
    set fp [open $form(f) r]
      set fd [read $fp]
    close $fp
    set fn $form(f)
  } errmsg] {
    set fd ""
    puts "<span style=\"color:red; font-weight:bold;\">$errmsg</span><br>"
  }

  puts "<p><!-pre>
<table id=\"table1\" border=1 width=\"99%\" align=\"center\"
       style=\"font: 100% Courier, monospace; !-font-family: Consolas, Roboto Mono, Menlo, Courier New, Courier;\">"
  puts "<tr><th width=1%>[file tail $form(f)]</th></tr>"

  set lines [split [string map $conv_html [string trim $fd]] "\n"]
  for {set li -1} {[incr li] < [llength $lines]} {} { set l [lindex $lines $li] ; # --- vorwaerts!
    # if { $l == "" } { continue }
    puts "<tr bgcolor=\"[lindex $bgcols [expr $li % 2]]\"><td>$l</td></tr>"
  }

  puts "</table></pre>"

  puts "<script type='text/javascript' language='javascript' src='TableFilter/tablefilter.js'></script>
<script language='javascript' type='text/javascript'>var tf = setFilterGrid('table1',1);</script>"

  puts "<p># $form(f): [string length $fd] Byte(s), [llength $lines] Zeile(n)"
  puts "vom [clock format [file mtime $form(f)] -format "%d.%m.%y um %H:%M:%S"] Uhr"


} elseif { [info exists form(f)] && [string first "\[rega\] " $form(f)] == 0 } {

  # ---
  if { [string first "$HB_ARCHIVE_DIR/" $form(f)] > -1
        && (    [string first "-HistoryBuffer.csv"          $form(f)] > -1 
             || [string first "-HistoryBuffer-complete.csv" $form(f)] > -1
           )
  } {
  # ---

    if [catch {
      set fp [open [string range $form(f) 7 end] r]
        set fd [read $fp]
      close $fp
      set fn $form(f)
    } errmsg] {
      set fd ""
      puts "<span style=\"color:red; font-weight:bold;\">$errmsg</span><br>"
    }

    set fn ""
    set DATE_FORMAT_SMALL 1
    set HEADLINES 0

  # ---
  } elseif { $form(f) != "\[rega\] Systemprotokoll" } {
  # ---

    set cmd [string range $form(f) 7 end]
    # puts "rega cmd: '$cmd'<p>"

    set fd ""

    if { $cmd == "Servicemeldungen" } {

      array set HMvars [rega_script {
  string slist;
  object oTmpArray = dom.GetObject(ID_SERVICES);
  if(oTmpArray) {
    string sTmp;
    foreach(sTmp, oTmpArray.EnumIDs()) {
      object oTmp = dom.GetObject(sTmp);
      if (oTmp) {
        if(oTmp.IsTypeOf(OT_ALARMDP) && (oTmp.AlState() == asOncoming)) {
          object trigDP = dom.GetObject(oTmp.AlTriggerDP());
          var sdesc = trigDP.HssType();
          object och = dom.GetObject((trigDP.Channel()));
          object odev = dom.GetObject((och.Device()));
          time sftime = oTmp.AlOccurrenceTime(); ! erste Meldezeit
          time sltime = oTmp.LastTriggerTime(); ! letze Meldezeit
          slist = slist # odev.Name() # " | " # sdesc # " (" # sftime.Format("%y-%m-%d / %H:%M:%S") # ")\n";
          WriteLine( ','
                   # ',' # odev.Name()
                   # ',' # odev.HssType() # " / " # odev.Address() # " / " # sltime.Format("%d.%m.%y %H:%M:%S")
                   # ',' # sdesc
                   # ',' # sftime.Format("%Y-%m-%d %H:%M:%S")
          );
    } } }
  }
  !---WriteLine(slist);
      }]

      # puts "<pre>$HMvars(STDOUT)</pre>"
        set HMvars(STDOUT) [exec echo "$HMvars(STDOUT)" | sort -t, -k5]; # --- nach Meldungstyp
      # puts "<pre>$HMvars(STDOUT)</pre>"

      # set fd $HMvars(STDOUT)
      # --- Zeilenende 0d0a auf Standard 0a aendern: ---
        regsub -all "[format %c 13]" [string trim $HMvars(STDOUT)] {} fd

      set fn "Servicemeldungen-[clock format [clock seconds] -format %y%m%d_%H%M%S].txt"
      set DATE_FORMAT_SMALL 0
      set HEADLINES 0
      set SHOW_UNITS 1
      set TABLE_HEADER "<tr><th width=1%>erste Meldung</th><th width=50%>Name</th><th>Meldung</th><th>Typ / Adresse / letzte Meldung</th></tr>"

    } elseif { $cmd == "Systemvariablen" } {

      array set HMvars [rega_script {
        string id;
        foreach( id, dom.GetObject(ID_SYSTEM_VARIABLES).EnumUsedIDs() ) {
          WriteLine( ','
                   # ',' # dom.GetObject(ID_SYSTEM_VARIABLES).Get( id ).Name()
                   # ',' # dom.GetObject(ID_SYSTEM_VARIABLES).Get( id ).Value()
                   # ',' # dom.GetObject(ID_SYSTEM_VARIABLES).Get( id ).Value().Type()
                   # ',' # dom.GetObject(ID_SYSTEM_VARIABLES).Get( id ).Timestamp().ToString("%Y-%m-%d %H:%M:%S")
          );
        }
      }]

      # --- Zeilenende 0d0a auf Standard 0a aendern: ---
      regsub -all "[format %c 13]" [string trim $HMvars(STDOUT)] {} fd

      set fn "Systemvariablen-[clock format [clock seconds] -format %y%m%d_%H%M%S].csv"
      set DATE_FORMAT_SMALL 0
      set HEADLINES 0
      set SHOW_UNITS 1


    } elseif { $cmd == "Geraete" || $cmd == "Ger&auml;te" || $cmd == "Geräte" } {

      array set HMvars [rega_script {
        string id;
        foreach( id, dom.GetObject(ID_DEVICES).EnumUsedIDs() ) {
          var timestamp = '1970-01-01 01:00:00';

          var unreachable = '-';
          object aldp_obj = dom.GetObject( 'AL-' # dom.GetObject(ID_DEVICES).Get( id ).Address() # ':0.UNREACH' );
          if ( ! aldp_obj ) { 
          object aldp_obj = datapoints.Get( 'HmIP-RF.' # dom.GetObject(ID_DEVICES).Get( id ).Address() # ':0.UNREACH' );
          }
          if (aldp_obj) {
            if ( aldp_obj.Value()     ) { unreachable = 'UNREACH'; } else { unreachable = 'reachable'; }
       !--- if (  ( aldp_obj.Timestamp() )  &&  ( aldp_obj.Timestamp().ToString() > timestamp )  ) { timestamp = aldp_obj.Timestamp().ToString(); }
          }

          var lowbat = '-';
          object aldp_obj = dom.GetObject( 'AL-' # dom.GetObject(ID_DEVICES).Get( id ).Address() # ':0.LOWBAT' );
          if ( ! aldp_obj ) {
          object aldp_obj = datapoints.Get( 'HmIP-RF.' # dom.GetObject(ID_DEVICES).Get( id ).Address() # ':0.LOW_BAT' );
          }
          if (aldp_obj) { 
            if (aldp_obj.Value()) { lowbat = 'LOWBAT'; } else { lowbat = 'battery ok'; }
       !--- if (  ( aldp_obj.Timestamp() )  &&  ( aldp_obj.Timestamp().ToString() > timestamp )  ) { timestamp = aldp_obj.Timestamp().ToString(); }
          }

          var state = '-'; integer ch = 1;
          !- state.VarType(): 4 (string)

          if(        dom.GetObject(ID_DEVICES).Get( id ).HssType() == 'HmIP-PS-2' ) { ch = 2; ! --- Schaltsteckdose (EG-Kueche-LED-Strahler) - Statusmitteilung Schaltausgang
          } elseif ( dom.GetObject(ID_DEVICES).Get( id ).HssType() == 'HmIP-BSM'  ) { ch = 3; ! --- Unterputzschalter (EG-Kueche-LED-Spuele) - Statusmitteilung Schaltausgang
          } elseif ( dom.GetObject(ID_DEVICES).Get( id ).HssType() == 'HmIP-BSL'  ) { ch = 3; ! --- Unterputzschalter_mit_LED (OG_Flur) - Statusmitteilung Schaltausgang
          }

          object aldp_obj = dom.GetObject(ID_CHANNELS).Get( dom.GetObject(ID_DEVICES).Get( id ).Name() # ":" # ch.ToString() );
          if( aldp_obj.DPByHssDP('STATE') ) {
            !- WriteLine( '\naldp_obj: ' # aldp_obj );
            !- WriteLine( aldp_obj.DPByHssDP('STATE').Value() );
            !- WriteLine( aldp_obj.LastDPActionTime() );
            state = aldp_obj.DPByHssDP('STATE').Value();
            if(  ( aldp_obj.LastDPActionTime() )  &&  ( 1|| aldp_obj.LastDPActionTime().ToString() > timestamp )  ) { timestamp = aldp_obj.LastDPActionTime().ToString(); }

          } else {

          object aldp_obj = dom.GetObject( 'BidCos-RF.' # dom.GetObject(ID_DEVICES).Get( id ).Address() # ':' # ch # '.STATE' );
          if ( ! aldp_obj ) {
          object aldp_obj = datapoints.Get(  'HmIP-RF.' # dom.GetObject(ID_DEVICES).Get( id ).Address() # ':' # ch # '.STATE' );
          }
          if (aldp_obj) {
            state = aldp_obj.Value();
            if (  ( aldp_obj.Timestamp() )  &&  ( 1|| aldp_obj.Timestamp().ToString() > timestamp )  ) { timestamp = aldp_obj.Timestamp().ToString(); }
          }

          }
          !- WriteLine( 'ch - state - timestamp: ' # ch # ' - ' # state # '/' # state.VarType() # ' - ' # timestamp );

          string ts_ch = '';
          if (  ( state.VarType() == 4 ) || ( timestamp == '1970-01-01 01:00:00' )  ) {
       !--- WriteLine( '### --- ID_DEVICES_id: ' # id # ' ---' );
            string sChnId;
            foreach( sChnId, dom.GetObject(ID_DEVICES).Get( id ).Channels() ) {    
         !--- WriteLine( dom.GetObject(sChnId).Name() # ' / ' # dom.GetObject(sChnId).LastDPActionTime().ToString() );
              if( dom.GetObject(sChnId).LastDPActionTime() && dom.GetObject(sChnId).LastDPActionTime().ToString() > timestamp ) {
	        timestamp = dom.GetObject(sChnId).LastDPActionTime().ToString(); 
                ts_ch = ' (* ts_ch: ' # dom.GetObject(sChnId).Name() # ' )';
              }
            }
          }

          WriteLine( ','
                   # ',' # dom.GetObject(ID_DEVICES).Get( id ).Name()
                   # ',' # dom.GetObject(ID_DEVICES).Get( id ).HssType()
                         # ' / ' # state # ' / ' # unreachable # ' / ' # lowbat # ts_ch
                   # ',' # dom.GetObject(ID_DEVICES).Get( id ).Address()
                   # ',' # timestamp
          );
        }
      }]

      # --- Zeilenende 0d0a auf Standard 0a aendern: ---
      regsub -all "[format %c 13]" [string trim $HMvars(STDOUT)] {} fd

      set fn "Geraete-[clock format [clock seconds] -format %y%m%d_%H%M%S].csv"
      set DATE_FORMAT_SMALL 0

      set HEADLINES 0
      set SHOW_UNITS 1
      set TABLE_HEADER "<tr><th width=1%>Zeit</th><th width=1%>Name</th><th width=1%>Adresse</th><th !width=40%>Typ / Status / Ereichbarkeit / Batterie</th></tr>"


    } elseif { $cmd == "Programme" } {

      array set HMvars [rega_script {
        string id;
        foreach( id, dom.GetObject(ID_PROGRAMS).EnumUsedIDs() ) {
          WriteLine( ','
                   # ',' # dom.GetObject(ID_PROGRAMS).Get( id ).Name()
                   # ',' # dom.GetObject(ID_PROGRAMS).Get( id ).Internal()
                   # ',' # dom.GetObject(ID_PROGRAMS).Get( id ).Active()
                   # ',' # dom.GetObject(ID_PROGRAMS).Get( id ).ProgramLastExecuteTime().ToString('%Y-%m-%d %H:%M:%S')
          );
        }
      }]

      set HMvars(STDOUT) [exec echo "$HMvars(STDOUT)" | sort -t, -k6]; # nach Zeit
    # set HMvars(STDOUT) [exec echo "$HMvars(STDOUT)" | sort -t, -k6 -r]; # nach Zeit
    # set HMvars(STDOUT) [exec echo "$HMvars(STDOUT)" | sort -t, -k3]; # nach Name

      # --- Zeilenende 0d0a auf Standard 0a aendern: ---
      regsub -all "[format %c 13]" [string trim $HMvars(STDOUT)] {} fd

      set fn "Programme-[clock format [clock seconds] -format %y%m%d_%H%M%S].csv"
      set DATE_FORMAT_SMALL 0
      set HEADLINES 0
      set SHOW_UNITS 1
      set TABLE_HEADER "<tr><th width=1%>letzte Ausf&uuml;hrung</th><th width=50%>Programm</th><th width=1%>aktiv</th><th width=1%>intern</th></tr>"
    # set STOP_RELOAD 1
    }

  # ---
  } else {
  # ---

  # --- $form(f) == "\[rega\] Systemprotokoll": ---

  set ccu_postdata "{\"method\":\"Session.login\",\"params\":{\"username\":\"$ccu_user\",\"password\":\"$ccu_password\"}}"

  if {0} {
    set loginresponse "{\"version\": \"1.1\",\"result\": \"uXTWq2gxWZ\",\"error\": null}"

  } else {
    if [catch {
      set loginresponse [exec wget --timeout=5 --tries=2 -q -O - "http://$ccu_host/api/homematic.cgi" --post-data $ccu_postdata]
          } errmsg] {
      puts "# loginresponse: $errmsg"
      exit
    }
  }

  puts "<!-- # loginresponse: $loginresponse -->"
  # zB: {"version": "1.1","result": "uXTWq2gxWZ","error": null}

  if {    ( [string first ",\"error\": null\}" $loginresponse] == -1 )
       || ( ! [regexp {"version": "(.*)","result": "(.*)",} $loginresponse dummy version result] )
  } {
    puts "loginresponse fehlerhaft, Abbruch!<br>"
    if [regexp {"message": "([^"]*)"} $loginresponse dummy message] {
      puts "<span style=\"color:red; font-weight:bold;\"><pre>$message</pre></span>"
    } else {
      puts "<span style=\"color:red; font-weight:bold;\"><pre>$loginresponse</pre></span>"
    }
    exit
  }

  puts "<!-- # version: $version, result: $result; -->"

  # ---

  if [catch {
      set fd [exec wget -q -O - "http://$ccu_host/HistoryBuffer.csv?sid=@$result@" 
      # | sed "s/\\n/_XXX_/g;"
      # | tr -d "\\n"
      # | tr -d "\\n" | sed "s/\\^M/\\n/g;" 
                        ]
          } errmsg] {
    puts "# wget HistoryBuffer.csv: $errmsg"
    set fd ""
  }

  # ---

  if { $fd != "" && $SAVE2HB_ARCHIV_ONLY } {

    ### --- original-Daten "retten", da $fd noch konvertiert wird! ---
    ### nutzlos, da ja durch $fd iteriert wird! ### set SAVE2FILE_DATA $fd

    set SAVE2FILE_PRE      [clock format       [clock seconds]        -format %Y-%m-%d]
    set SAVE2FILE_PRE_YEST [clock format [expr [clock seconds]-86400] -format %Y-%m-%d]

    set SAVE2FILE_P        "$HB_ARCHIVE_DIR/[string range $SAVE2FILE_PRE      0 3]"
    set SAVE2FILE_P_YEST   "$HB_ARCHIVE_DIR/[string range $SAVE2FILE_PRE_YEST 0 3]"
    # set SAVE2FILE_P        "/var/tmp/HB_Archive/[string range $SAVE2FILE_PRE      0 3]"
    # set SAVE2FILE_P_YEST   "/var/tmp/HB_Archive/[string range $SAVE2FILE_PRE_YEST 0 3]"

    set SAVE2FILE_N        "$SAVE2FILE_PRE-HistoryBuffer-complete.csv"
    set SAVE2FILE_N_YEST   "$SAVE2FILE_PRE_YEST-HistoryBuffer-complete.csv"
    set SAVE2FILE_PN       "$SAVE2FILE_P/$SAVE2FILE_N"
    set SAVE2FILE_PN_YEST  "$SAVE2FILE_P_YEST/$SAVE2FILE_N_YEST"
    
    puts "\n# - SAVE2FILE_YEST: \"$SAVE2FILE_PN_YEST\""
    if [catch {
      set fp [open $SAVE2FILE_PN_YEST r]
        set SAVE2FILE_DATA_OLD_YEST [read $fp]
      close $fp
    # puts "([string length $SAVE2FILE_DATA_OLD_YEST] Bytes eingelesen)"
      puts "([file size $SAVE2FILE_PN_YEST] Bytes, [clock format [file mtime $SAVE2FILE_PN_YEST] -format "%d.%m.%y / %H:%M"] Uhr)"
    } errmsg] {
      set SAVE2FILE_DATA_OLD_YEST ""
      puts "($errmsg)"
    }

    puts "\n# - SAVE2FILE: \"$SAVE2FILE_PN\""
    if [catch {
      set fp [open $SAVE2FILE_PN r]
        set SAVE2FILE_DATA_OLD [read $fp]
      close $fp
    # puts "([string length $SAVE2FILE_DATA_OLD] Bytes eingelesen)"
      puts "([file size $SAVE2FILE_PN] Bytes, [clock format [file mtime $SAVE2FILE_PN] -format "%d.%m.%y / %H:%M"] Uhr)"
    } errmsg] {
      set SAVE2FILE_DATA_OLD ""
      puts "($errmsg)"
    }

    puts ""

  }

  # ---

  set fd [encoding convertfrom utf-8 $fd]

  # ---

  set ccu_postdata "{\"method\":\"Session.logout\",\"params\":{\"_session_id_\":\"$result\"}}"

  if [catch {
        set logoutresponse [exec wget --timeout=5 --tries=2 -q -O - "http://$ccu_host/api/homematic.cgi" --post-data $ccu_postdata]
          } errmsg] {
    puts "#logoutresponse: $errmsg"

  } else {
    puts "<!-- # logoutresponse: $logoutresponse -->"
  }

  # ---

  if {0} {
  # --- CCU2: ---
  set fd {CHANNEL-ID,CHANNEL,VALUE-ID,VALUE,UNIT,DATE TIME
,,WZ_Temp,19.800000,,2022-03-23 09:20:15
,,WZ_Feucht,38.000000,,2022-03-23 09:20:20
,,Aussen_Temp,7.000000,,2022-03-23 09:20:25
,,Aussen_Feucht,71.000000,,2022-03-23 09:20:25
,,Aussen_Temp_max,7.000000,,2022-03-23 09:20:25
LEQ0230324:2,"HM-OU-CFM-Pl LEQ0230324:2 Gong",STATE,1,,2022-03-23 20:04:15
LEQ0230324:2,"HM-OU-CFM-Pl LEQ0230324:2 Gong",STATE,0,,2022-03-23 20:04:18
,,LED16log,20022222.00300303|3425741442|2022-04-08 11:26:18*,,2022-04-08 11:26:18
MEQ1516080:1,"HM-OU-LED16 MEQ1516080:1 Alarm_scharf",LED_STATUS,2,,2022-04-08 11:26:18
,,log,Prog: pHmIP-BSL-Statusanzeige-OG_Flur --- Trigger: LED16log,,2022-04-08 11:26:19
,,WZ_Feucht,45.000000,,2022-04-08 11:26:20
,,Aussen_Temp,7.600000,,2022-04-08 11:26:25
,,Aussen_Feucht,80.000000,,2022-04-08 11:26:25
,,log,Prog: pZuKaltFuerFensterOffen --- LastProgramTrigger: Aussen_Temp,,2022-04-08 11:26:26
,,log,Prog: LED16-Statusanzeige --- vergleiche Led16-SOLL (LED16log) mit -IST und korrigiere ggf. ---,,2022-04-08 11:26:48
,,log,Prog: pHKT_Absenkung_all (pHKT_Absenkung_all-Skript) --- Trigger: HM-CC-RT-DN SEQ2547020:4,,2022-04-08 11:28:04
,,log,Prog: pHKT_Absenkung_all (pHKT_Absenkung_all-Skript) --- Trigger: HM-CC-RT-DN OEQ2089938:4,,2022-04-08 11:29:08
MEQ1112472:1,"HM-Sec-Key MEQ1112472:1 Tuerschloss",STATE,1,,2022-04-08 11:29:56
MEQ1112472:1,"HM-Sec-Key MEQ1112472:1 Tuerschloss",STATE_UNCERTAIN,1,,2022-04-08 11:29:56
MEQ1112472:1,"HM-Sec-Key MEQ1112472:1 Tuer"test"schloss",ERROR,0,,2022-04-08 11:29:56
,,log,systemstate.sh --- shell-script per "cron",,2022-04-08 11:30:22}

# --- "f=[rega] Systemvariablen" ---
#,,Aussen_Feucht,90.000000,,2022-04-02 09:34:25
#,,Aussen_Feucht_abs,3.529250,,2022-04-02 09:33:08
#,,Aussen_Feucht_max,91.000000,,2022-04-02 00:00:06
#,,Aussen_Feucht_min,90.000000,,2022-04-02 08:59:25
#,,Aussen_Temp,0.600000,,2022-04-02 09:34:25
#,,Aussen_Temp_max,0.600000,,2022-04-02 09:34:25

  } elseif {0} {
  # --- RM: ---
  set fd {CHANNEL-ID;CHANNEL;VALUE-ID;VALUE;UNIT;DATE TIME
;;Rollo_Automatik;"0";;2022-01-16 12:54:59
;;Protokolleintrag;"ACHTUNG: Reboot der CCU - Status Balkontür aktualisieren";;2022-01-16 12:54:59
;;Protokolleintrag;" DANN Prg-ID: 3859 / Prg-Name: PGM_Bootprogramm / kein Ausloeser = nach CCU-Reboot (ReGaHss Neustart) oder durch Aktivieren gestartet = ";;2022-01-16 12:54:59
;;Licht_Automatik;"0";;2022-01-16 12:54:59
;;Protokolleintrag;"*PGM_Schatten-Level* 
 SONST (normale Beschattung)  durch  kein Ausloeser nach CCU-Reboot (ReGaHss Neustart) oder durch Aktivieren gestartet und dem Wert:
 um: 16.01. 12:55 Uhr";;2022-01-16 12:55:19
;;Protokolleintrag;"init value";;2022-01-16 12:55:21
;;Protokolleintrag;"NEUE Servicemeldung
Lichtsensor_WZ_West : 
hat Kommunikationsfehler 
seit: 16.01.22 12:55 (16.01.22 12:55)

";;2022-01-16 12:55:40
;;Licht_"Auto"matik;"1";;2022-01-16 12:56:08
LEQ0529290:1;"HM-ES-PMSw1-Pl LEQ0529290:1";STATE;"1";;2022-03-23 20:11:04
0001D3C99CA0D2:3;"HMIP-PSM 0D2 Kanal :3 - Schaltaktor";STATE;"1";;2022-03-23 20:12:11
0001D3C99CA0D2:3;"HMIP-PSM 0D2 Kanal :3 - Schaltaktor";STATE;"0";;2022-03-23 20:12:19
LEQ0529290:1;"HM-ES-PMSw1-Pl LEQ0529290:1";STATE;"0";;2022-03-23 20:12:55}

  }

    set fn "HistoryBuffer-[clock format [clock seconds] -format %y%m%d_%H%M%S].csv"
    set DATE_FORMAT_SMALL 1
    set HEADLINES 1

  # ---
  } 
  # ---

  if { ! $SAVE2HB_ARCHIV_ONLY } {

  puts "<p><!-pre>
<table id=\"table1\" border=1 width=\"99%\" align=\"center\" 
       style=\"!-font-family: Consolas, Roboto Mono, Menlo, Courier New, Courier;\">"

  if ![info exists TABLE_HEADER] {
    if { [info exists SHOW_UNITS] && $SHOW_UNITS == 1 } { set UNIT_TH "<th width=1%>Typ</th>" } else { set UNIT_TH "" }
    puts "<tr><th width=1%>Zeit</th><th width=1%>Kanal / Variable</th>$UNIT_TH<th>Aktivit&auml;t / Wert</th></tr>"
  } else {
    puts $TABLE_HEADER
  }

  }; # --- endif: ! SAVE2HB_ARCHIV_ONLY

  # ---

  set lines [split [string trim $fd] "\n"]

  if { $SAVE2HB_ARCHIV_ONLY } {
    puts -nonewline "\n# $form(f): [string length $fd] Byte(s), [expr [llength $lines] - $HEADLINES] Zeile(n), bis: ..."
    puts [string range $fd [expr [string length $fd]-20] end] 
  }

  ### foreach l [split $fd "\n"] { puts "<tr><td>$l</td></tr>" }
  ### for {set li [llength $lines]} {[incr li -1] >= 1} {} ### set l [lindex $lines $li] ; # --- rueckwaerts!

  set lcomplete 1
  set DATA_AiO ""
  set old_start      ""
  set old_start_yest "-.-"
  set new_start_yest ""

  for {set li [expr -1 + $HEADLINES]} {[incr li] < [llength $lines]} {} { set l [lindex $lines $li] ; # --- vorwaerts!
    # puts "# $li: $l<br>"
    # set hexdump [exec echo -ne "$l" | hexdump -C]; puts "<pre>$hexdump</pre>"

    if { $DATA_AiO == "" } { set DATA_AiO_start $li }

    if { [regexp {([^,]*),([^,]*),([^,]*),(.*),([^,]*),(....-..-.. ..:..:..)$} $l dummy CHANNELID CHANNEL VALUEID VALUE UNIT DATETIME]
      || [regexp {([^;]*);([^;]*);([^;]*);(.*);([^;]*);(....-..-.. ..:..:..)$} $l dummy CHANNELID CHANNEL VALUEID VALUE UNIT DATETIME]
    } {
      set lcomplete 1
      append DATA_AiO "$l\n"

    } elseif { $lcomplete
          && (    [regexp {([^,]*),([^,]*),([^,]*),(.*)$} $l dummy CHANNELID CHANNEL VALUEID VALUEpart]
               || [regexp {([^;]*);([^;]*);([^;]*);(.*)$} $l dummy CHANNELID CHANNEL VALUEID VALUEpart] ) } {
      set VALUE $VALUEpart
      set lcomplete 0
      append DATA_AiO "$l\n"

    } elseif { ( ! $lcomplete )
          && (    [regexp {(.*),([^,]*),(....-..-.. ..:..:..)$} $l dummy VALUEpart UNIT DATETIME]
               || [regexp {(.*);([^;]*);(....-..-.. ..:..:..)$} $l dummy VALUEpart UNIT DATETIME] ) } {
      append VALUE "<br>\n$VALUEpart"
      set lcomplete 1
      append DATA_AiO "$l\n"


    } elseif { ( ! $lcomplete ) } {
      append VALUE "<br>\n$l"
      append DATA_AiO "$l\n"

    }

    if $lcomplete {

      if { $SAVE2HB_ARCHIV_ONLY && [info exists SAVE2FILE_PN] && $SAVE2FILE_PN != "" } {
        set DATA_AiO [string trim $DATA_AiO]

        # puts "[string range $DATA_AiO [expr [string length $$DATA_AiO]-21] [expr [string length $$DATA_AiO]-20+10]];"
        # puts  ",[string range $DATETIME 0 10];"
        ###     [string range $DATA_AiO [expr [string length $$DATA_AiO]-21] [expr [string length $$DATA_AiO]-20+10]]

        if { ",[string range $DATETIME 0 10]" == ",$SAVE2FILE_PRE_YEST " } {
          # --- gestern-Zeile: ---
          if { 0&& $SAVE2FILE_DATA_OLD_YEST == "" } {
            if { $old_start_yest != "" } {
              set old_start_yest ""
              puts "\n# (gestern, keine csv-Datei vorhanden, skip: ...,$DATETIME) - ab Zeile $DATA_AiO_start/[expr [llength $lines]-1] -\n..."
            }
          } else {
            if { [string first $DATA_AiO $SAVE2FILE_DATA_OLD_YEST] == -1 } {
              if { $new_start_yest == "" } {
                set new_start_yest $DATA_AiO_start
                puts "\n# neu, gestern: ...,$DATETIME - ab Zeile $DATA_AiO_start/[expr [llength $lines]-1] -\n..."
              }
            } else {
              if { $old_start_yest == "-.-" } { 
                puts "\n# (bekannt, gestern: ...,$DATETIME) - ab Zeile $DATA_AiO_start/[expr [llength $lines]-1] -\n..."
                set old_start_yest $DATETIME
              }
            }
          }

        } elseif { ",[string range $DATETIME 0 10]" == ",$SAVE2FILE_PRE " } {
          # --- heute-Zeile: ---

          # --- ggf gestern-Zeilen noch speichern, alle auf einmal: ---
          if { $new_start_yest != "" } {
            catch { exec mkdir "$SAVE2FILE_P_YEST/" }

            puts "\n# neu, gestern (Zeile(n) $new_start_yest - [expr $DATA_AiO_start-1])"
          # exec echo -e "[join [lrange $lines $new_start_yest [expr $DATA_AiO_start-1]] "\n"]" >> "$SAVE2FILE_PN_YEST"
            set fp [open $SAVE2FILE_PN_YEST a]
              puts $fp [join [lrange $lines $new_start_yest [expr $DATA_AiO_start-1]] "\n"]
            close $fp 
            puts   "# [expr $DATA_AiO_start - $new_start_yest +1] Zeile(n) gespeichert!"
            set new_start_yest ""
          }

          # --- heute-Zeilen speichern, alle auf einmal: ---
          if { [string first $DATA_AiO $SAVE2FILE_DATA_OLD] == -1 } {
            catch { exec mkdir "$SAVE2FILE_P/" }

            puts "\n# neu, heute (Zeile(n) $DATA_AiO_start-[expr [llength $lines]-1]): ...,$DATETIME"
          # exec echo -e "[join [lrange $lines $DATA_AiO_start end] "\n"]" >> "$SAVE2FILE_PN"
            set fp [open $SAVE2FILE_PN a]
              puts $fp [join [lrange $lines $DATA_AiO_start end] "\n"]
            close $fp 
            puts -nonewline "# [expr [llength $lines] - $DATA_AiO_start] Zeile(n) gespeichert, neueste: ..."
            puts [string range $fd [expr [string length $fd]-20] end] 

            puts "\n# $SAVE2FILE_PN_YEST"
            if { [catch { 
              puts   "([file size $SAVE2FILE_PN_YEST] Bytes, [clock format [file mtime $SAVE2FILE_PN_YEST] -format "%d.%m.%y / %H:%M"] Uhr)"
                        } errmsg] } { puts "($errmsg)"}

            puts "\n# $SAVE2FILE_PN"
            puts   "([file size $SAVE2FILE_PN] Bytes, [clock format [file mtime $SAVE2FILE_PN] -format "%d.%m.%y / %H:%M"] Uhr)"

            exit

          } else {
            if { $old_start == "" } { 
              puts "\n# (bekannt, heute: ...,$DATETIME) - ab Zeile $DATA_AiO_start/[expr [llength $lines]-1] -\n..."
              set old_start $DATETIME
            }
          }

        }

      } else {

      puts "<tr bgcolor=\"[lindex $bgcols [expr $li % 2]]\"><td nowrap><!-- #$li -->"
      if { $DATE_FORMAT_SMALL } {
        puts "[string range $DATETIME 8 9].[string range $DATETIME 5 6]. [string range $DATETIME 11 end]"
      } else {
        puts "[string range $DATETIME 8 9].[string range $DATETIME 5 6].[string range $DATETIME 2 3] [string range $DATETIME 11 end]"
      }
      puts "</td>"

      # regexp {^&quot;(.*)&quot;$} $VALUE dummy VALUE

      set VALUE [string map $conv_html $VALUE]
      set VALUE [string map "{&lt;br&gt;\n} {<br>\n}" $VALUE]

      if { $CHANNEL != "" } {
        # regexp {^&quot;(.*)&quot;$} $CHANNEL dummy CHANNEL
        puts "<td nowrap>[string trim $CHANNEL '"']</td>"
        if { [info exists SHOW_UNITS] && $SHOW_UNITS == 1 } { puts "<td align=center>$UNIT</td>" }
        puts "<td !-style=\"word-wrap: break-word\">$VALUEID:[string trim $VALUE '"']</td></tr>" 
      } else {
        puts "<td nowrap>$VALUEID</td>"
        if { [info exists SHOW_UNITS] && $SHOW_UNITS == 1 } { puts "<td align=center>$UNIT</td>" }
        puts "<td !-style=\"word-wrap: break-word\">[string trim $VALUE '"']</td></tr>" 
      }

      }; # --- end: if SAVE2FILE_PN != "" / else ...

      set DATA_AiO ""
    }; # --- end: if lcomplete ...
  }

  # ---

  if { ! $SAVE2HB_ARCHIV_ONLY } {

    puts "</table></pre>"
    puts "<p># $form(f): [string length $fd] Byte(s), [expr [llength $lines] - $HEADLINES] Zeile(n)"

    if {       [file exists $form(f)                     ] } {
      puts "vom [clock format [file mtime $form(f)]                      -format "%d.%m.%y um %H:%M:%S"] Uhr"
    } elseif { [file exists [string range $form(f) 7 end]] } {
      puts "vom [clock format [file mtime [string range $form(f) 7 end]] -format "%d.%m.%y um %H:%M:%S"] Uhr"
    }

    puts "<br>"

  } else {
    # puts "\n# $form(f): [string length $fd] Byte(s), [expr [llength $lines] - $HEADLINES] Zeile(n)"
    puts   "\n# - nichts neues -"
    exit
  }

  puts "<script type='text/javascript' language='javascript' src='TableFilter/tablefilter.js'></script>
<script language='javascript' type='text/javascript'>var tf = setFilterGrid('table1',1);</script>"

  puts "<p>"

  # ---

  if { $fn != "" && [string length $fd] <= 500000 } {
    if ![catch { source [file join [file dirname [info script]] proc_urlencode.tcl] }] {
      puts "<a href=\"data:text/plain;charset=utf-8,[uencode $fd]\"
       download=\"[file tail $fn]\"><button>Download</button></a>"
      puts " &nbsp; &nbsp; &nbsp; -oder- &nbsp; &nbsp; &nbsp; " 
    } else {
      puts "<!-- import proc_urlencode.tcl failed: no download-button! -->"
    }
  }

  # ---

  if {  [info exists form(f)] && [info exists fd]
     && !( 0&& [string first "$HB_ARCHIVE_DIR/" $form(f)] > -1
           && (  [string first "-HistoryBuffer.csv"          $form(f)] > -1 
              || [string first "-HistoryBuffer-complete.csv" $form(f)] > -1
              )
         )
  } {
    puts "<script type='text/javascript'>
  function handleClick(cb) {
    if( cb.checked ) { document.getElementById('predata').style.display='';
              } else { document.getElementById('predata').style.display='none' }
  }
</script>
<input type='checkbox' onclick='handleClick(this);' name='showdata'> show data ..."

  # puts "<pre id=\"predata\" style=\"display:none\">$fd</pre>"
    puts "<pre id=\"predata\" style=\"display:none\">[string map $conv_html $fd]</pre>"
    # CHANNEL-ID,CHANNEL,VALUE-ID,VALUE,UNIT,DATE TIME
  }

  # ---

  if {0} {
    set hexdump [exec echo -ne "$fd" | hexdump -C]
    puts "<pre>$hexdump</pre>"
  }


} else {
  set fn ""
  set fd ""
}

# ---
# ---

} else {
  if {    ( [info exists fd]      && $fd      != "" )
       || ( [info exists form(f)] && $form(f) != "" ) 
  } {
    puts "<span style=\"color:red; font-weight:bold;\">--- unknown option ---</span><br>"
  }
}; # --- end: if { $selected } 

# ---
# ---

if { 1||  ( [info exists fd] && $fd != "" ) } {

  puts "<p id=\"bottom\" !-align=\"right\" style=\"background-color:rgba($rgba);\"
>\[$hostname\] [clock format [clock seconds] -format "%y-%m-%d / %H:%M:%S"]
([expr [clock seconds] - $scripttime]&thinsp;s) ---
<span id=\"time2reload_bottom\"></span>"

  if {  [info exists form(f)]
     && [string first "\[sh\] " $form(f)] == -1 
     && $form(f) != "\[rega\] Systemvariablen" 
     && $form(f) != "\[rega\] Geraete" 
     && $form(f) != "\[rega\] X-Programme" 
  } {
    puts "<script type='text/javascript'>setTimeout(\"window.scrollTo(0, document.getElementById('bottom').offsetTop);\",500)</script>"
  }

  puts "<div align=\"center\"><a href=\"#\" style=\"!-background-color:rgba($rgba); text-decoration: none;\"
  onclick=\"window.scroll(0,0)\"
  >&nbsp;<b>&bigtriangleup;&bigtriangleup;&bigtriangleup;</b>&nbsp;</a>
<span !-id=\"time2reload_bottom\"></span></div>"

}

# ---

if {    ( [info exist STOP_RELOAD] && $STOP_RELOAD == 1 )
     || ( ! $selected )
     || ( ! [info exists fd] )
     || ( 0&&  [string first "$HB_ARCHIVE_DIR/" $form(f)] > -1 && [string first "-HistoryBuffer.csv" $form(f)] > -1 )
     || ( [file exists $form(f)                     ] && [expr ( [clock seconds] - [file mtime $form(f)                     ] ) / 60 / 60] >= 6 )
     || ( [file exists [string range $form(f) 7 end]] && [expr ( [clock seconds] - [file mtime [string range $form(f) 7 end]] ) / 60 / 60] >= 6 )
} {
  puts "<script type='text/javascript'>document.getElementById(\"But_StopReload\").click();</script>"

} else {
  puts "<script type='text/javascript'>TimeoutShow();</script>"
}

# ---

puts "<!-- # scripttime: [expr [clock seconds] - $scripttime] s -->"
puts "</body>\n</html>"

